using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace R20
{
    public partial class form : Form
    {

        byte[] fdata = new byte[100]                                                                                                                                  
            {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x10,0x11,0x12,0x13,0x14,                                                                                 
            0x15,0x16,0x17,0x18,0x19,0x20,0x21,0x22,0x23,0x34,0x25,0x26,0x27,0x28,0x29,0x30,0x31,0x32,                                                                   
            0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x50,                                                                   
            0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,                                                                   
            0x69,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x80,0x81,0x82,0x83,0x84,0x85,0x86,                                                                   
            0x87,0x88,0x89,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99};
        
         int mHz = 7;
         int kHz = 0;
         int Hz = 0;
               
        int fUp = 0;
        int fDown = 0;

        long fStep=0;
        int fStepHZ = 0;
        int fStepKHZ = 0;
        int fStepMHZ = 0;
                
        long Freq = 0;

        byte iCustomStep = 0;
        byte sBreak = 0;

        byte iDial = 0;


        long sLoFreq = 430000000;
        long sHIFreq = 470000000;

        

        


        public form()
        {
            InitializeComponent();
        }
        
        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            serialPort1.Close();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            serialPort1.Open();
            //mHz=7;  kHz=0;   Hz=0;
            
            Freq = 7050500L;
            SetFreq();
            Application.DoEvents();
            ShowFreq(Freq);
            Application.DoEvents();
            fStep  = 1000;
            stepButton5.ForeColor = System.Drawing.Color.White;
            
        }  
        private void LSBbutton_Click(object sender, EventArgs e)
        {
            //LSB
            byte[] buffer = new byte[7] {0xFE,0xFE,0x6C,0x00,0x06,0x00,0xFD};
            serialPort1.Write(buffer,0,7);
        }

        private void CWbutton_Click(object sender, EventArgs e)
        {
            //CW
            byte[] buffer = new byte[7] { 0xFE, 0xFE, 0x6C, 0x00, 0x06, 0x03, 0xFD };
            serialPort1.Write(buffer, 0, 7);
        }

        private void USBbutton_Click(object sender, EventArgs e)
        {
            //USB
            byte[] buffer = new byte[7] { 0xFE, 0xFE, 0x6C, 0x00, 0x06, 0x01, 0xFD };
            serialPort1.Write(buffer, 0, 7);
        }

        private void WFMbutton_Click(object sender, EventArgs e)
        {
            //WFM
            byte[] buffer = new byte[7] { 0xFE, 0xFE, 0x6C, 0x00, 0x06, 0x06, 0xFD };
            serialPort1.Write(buffer, 0, 7);
        }

        private void FMbutton_Click(object sender, EventArgs e)
        {
            //FM
            byte[] buffer = new byte[7] { 0xFE, 0xFE, 0x6C, 0x00, 0x06, 0x05, 0xFD };
            serialPort1.Write(buffer, 0, 7);
        }

        private void AMbutton_Click(object sender, EventArgs e)
        {
            //AM
            byte[] buffer = new byte[7] { 0xFE, 0xFE, 0x6C, 0x00, 0x06, 0x02, 0xFD };
            serialPort1.Write(buffer, 0, 7);
        }

        private void SetFreq()

        {
            
            long input = Freq;

            //long input = 7999888;

            byte[] Result = new byte[5];

            Result[0] = (byte)(input % 100);
            input = input / 100;
            Result[1] = (byte)(input % 100);
            input = input / 100;
            Result[2] = (byte)(input % 100);
            input = input / 100;
            Result[3] = (byte)(input % 100);
            input = input / 100;
            Result[4] = (byte)(input % 100);

            byte[] buffer = new byte[11]; //[12]

            buffer[0] = 0xFE; //Sync
            buffer[1] = 0xFE; //Sync 
            buffer[2] = 0x6C; //Addr Receiver
            buffer[3] = 0x0E; //Addr Controller
            buffer[4] = 0x05; //Write Freq 

            buffer[5] = fdata[Result[0]];
            buffer[6] = fdata[Result[1]];
            buffer[7] = fdata[Result[2]];
            buffer[8] = fdata[Result[3]];
            buffer[9] = fdata[Result[4]];
            
            buffer[10] = 0xFD;  //End operation

            serialPort1.Write(buffer, 0, 11);//11)

            
            //long temp = Freq;
            //Hz = (int)(temp % 1000);

            //temp = Freq / 1000;
            //kHz = (int)(temp % 1000);
            //temp = Freq / 1000000;
            //mHz = (int)temp;

           //// tbOut.Text = Result[0].ToString().PadLeft(2, '0');
            
           //mHzlabel.Text = mHz.ToString()+".";
            ///////////kHzLabel.Text = kHz.ToString();
            ////////////hZlabel.Text = Hz.ToString();

            //kHzLabel.Text = kHz.ToString().PadLeft(3, '0');
            //hZlabel.Text = Hz.ToString().PadLeft(3, '0');
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if  (fUp == 1)
            {
                if (Freq < 3303999999)
                {
                    Freq = Freq +fStep ;
                    SetFreq();
                };
                
            };
           

            if (fDown == 1)
            {
                if (Freq - fStep > 150000)
                {
                    Freq = Freq - fStep;
                    SetFreq();
                };
                
            };
        }


        private void FreqUpPanel_MouseDown(object sender, MouseEventArgs e)
        {
            fUp = 1;
            FreqUpPanel.BackColor = System.Drawing.Color.Black;
        }

        private void FreqUpPanel_MouseUp(object sender, MouseEventArgs e)
        {
            fUp = 0;
            FreqUpPanel.BackColor = System.Drawing.Color.Silver;
        }

        private void FreqDownPanel_MouseDown(object sender, MouseEventArgs e)
        {
            fDown = 1;
            FreqDownPanel.BackColor = System.Drawing.Color.Black;
        }

        private void FreqDownPanel_MouseUp(object sender, MouseEventArgs e)
        {
            fDown = 0;
            FreqDownPanel.BackColor = System.Drawing.Color.Silver;
        }

        // dial processing
        string Dialed = "";
        string dMhz = "";
        string dKhz = "";
        string[] _Freq = { "", "" };

        private void Dial1Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "1";
        }

        private void Dial2Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "2";
        }

        private void Dial3Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "3";
        }

        private void Dial4Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "4";
        }

        private void Dial5Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "5";
        }

        private void Dial6Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "6";
        }

        private void Dial7Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "7";
        }

        private void Dial8Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "8";
        }

        private void Dial9Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "9";
        }

        private void Dial0Button_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + "0";
        }

        private void DialDOTButton_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + ".";
        }

        private void dialdot_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = true;
            Dialed = Dialed + ".";
        }

        private void DialEnterButton_Click(object sender, EventArgs e)
        {
          
        }

        private void DIALtimer_Tick(object sender, EventArgs e)
        {
            Dialed = "";
        }                // end off dial processing

        private void EXITbutton_Click(object sender, EventArgs e)
        {
            sBreak = 1;
            Application.DoEvents();
            Application.Exit();
        }

        private void stepButton1_Click(object sender, EventArgs e)
        {
            fStep = 10;
            stepButton1.ForeColor = System.Drawing.Color.White;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
            
            
        }

        private void stepButton2_Click(object sender, EventArgs e)
        {
            fStep = 50;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.White;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton3_Click(object sender, EventArgs e)
        {
            fStep = 100;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.White;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton4_Click(object sender, EventArgs e)
        {
            fStep = 5000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.White;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton5_Click(object sender, EventArgs e)
        {
            fStep = 1000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.White;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton6_Click(object sender, EventArgs e)
        {
            fStep = 5000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.White;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton7_Click(object sender, EventArgs e)
        {
            fStep = 25000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.White;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton8_Click(object sender, EventArgs e)
        {
            fStep = 50000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.White;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton9_Click(object sender, EventArgs e)
        {
            fStep = 100000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.White;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton10_Click(object sender, EventArgs e)
        {
            fStep = 500000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.White;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton11_Click(object sender, EventArgs e)
        {
            fStep = 250;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.White;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void stepButton12_Click(object sender, EventArgs e)
        {
            fStep = 10000;
            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.White;
            iCustomStep = 0;
            CustomStepButton.ForeColor = System.Drawing.Color.Black;
        }

        private void ESCbutton_Click(object sender, EventArgs e)
        {
            Dialed = "";
            sBreak = 1;
        }

        private void DoUpdate(object s, EventArgs e)
        {
            {
                int i = 0;

                byte[] buff = new byte[100];

                while (serialPort1.BytesToRead > 0)
                {
                    buff[i] = (byte)serialPort1.ReadByte();
                    i = i + 1;
                }

                ////
                
                ////

                string[] result = ParseResponce(buff);
                long newfreq = 0;


                switch (result[0])
                {
                    case "F":
                        newfreq = long.Parse(result[1], System.Globalization.NumberStyles.Integer);
                        ShowFreq(newfreq);
                        Freq = newfreq;
                        break;

                        break;
                    case "M":
                        textBox1.Text = result[2];
                        switch (result[2])
                        {
                            case "0": //LSB
                                // podsvechivaem panelku LSB
                                LSBbutton.ForeColor= System.Drawing.Color.White;
                                SWbutton.ForeColor = System.Drawing.Color.Black;
                                USBbutton.ForeColor = System.Drawing.Color.Black;
                                WFMbutton.ForeColor = System.Drawing.Color.Black;
                                FMbutton.ForeColor = System.Drawing.Color.Black;
                                AMbutton.ForeColor = System.Drawing.Color.Black;


                                break;

                            case "1": //USB
                                LSBbutton.ForeColor = System.Drawing.Color.Black;
                                SWbutton.ForeColor = System.Drawing.Color.Black;
                                USBbutton.ForeColor = System.Drawing.Color.White;
                                WFMbutton.ForeColor = System.Drawing.Color.Black;
                                FMbutton.ForeColor = System.Drawing.Color.Black;
                                AMbutton.ForeColor = System.Drawing.Color.Black;

                                break;

                            case "2": //AM
                                LSBbutton.ForeColor = System.Drawing.Color.Black;
                                SWbutton.ForeColor = System.Drawing.Color.Black;
                                USBbutton.ForeColor = System.Drawing.Color.Black;
                                WFMbutton.ForeColor = System.Drawing.Color.Black;
                                FMbutton.ForeColor = System.Drawing.Color.Black;
                                AMbutton.ForeColor = System.Drawing.Color.White;

                                break;


                            case "3": //CW
                                LSBbutton.ForeColor = System.Drawing.Color.Black;
                                SWbutton.ForeColor = System.Drawing.Color.White;
                                USBbutton.ForeColor = System.Drawing.Color.Black;
                                WFMbutton.ForeColor = System.Drawing.Color.Black;
                                FMbutton.ForeColor = System.Drawing.Color.Black;
                                AMbutton.ForeColor = System.Drawing.Color.Black;

                                break;


                            case "5": //FM
                                LSBbutton.ForeColor = System.Drawing.Color.Black;
                                SWbutton.ForeColor = System.Drawing.Color.Black;
                                USBbutton.ForeColor = System.Drawing.Color.Black;
                                WFMbutton.ForeColor = System.Drawing.Color.Black;
                                FMbutton.ForeColor = System.Drawing.Color.White;
                                AMbutton.ForeColor = System.Drawing.Color.Black;

                                break;


                            case "6": //WFM
                                LSBbutton.ForeColor = System.Drawing.Color.Black;
                                SWbutton.ForeColor = System.Drawing.Color.Black;
                                USBbutton.ForeColor = System.Drawing.Color.Black;
                                WFMbutton.ForeColor = System.Drawing.Color.White;
                                FMbutton.ForeColor = System.Drawing.Color.Black;
                                AMbutton.ForeColor = System.Drawing.Color.Black;

                                break;
                        }

                        break;
                }
                

            }
        }

        private string[] ParseResponce(byte[] b)
        {
            int CommStart = 0;
            bool CommFound = false;
            byte contaddr = 0;
            byte recaddr = 0;
            byte[] freq = new byte[5];
            string[] strRet = { "", "", "" };

            for (int i = 0; i <= b.Length - 1; i++)
            {
                if ((b[i] == 0xFE) && (b[i + 1] == 0xFE))
                {
                    CommFound = true;
                    CommStart = i;
                }

            }

            if (CommFound)
            {
                contaddr = b[CommStart + 2];
                recaddr = b[CommStart + 3];

                switch (b[CommStart + 4])
                {

                    // transfer freq data
                    case 0x00:
                        {
                            freq[0] = b[CommStart + 5];
                            freq[1] = b[CommStart + 6];
                            freq[2] = b[CommStart + 7];
                            freq[3] = b[CommStart + 8];
                            freq[4] = b[CommStart + 9];

                            strRet[0] = "F";
                            strRet[1] = String.Format("{0:x2}", freq[4]).ToUpper() + String.Format("{0:x2}", freq[3]).ToUpper() +
                                     String.Format("{0:x2}", freq[2]).ToUpper() + String.Format("{0:x2}", freq[1]).ToUpper() +
                                     String.Format("{0:x2}", freq[0]).ToUpper();
                            break;
                        }

                    // transfer mode
                    case 0x01:
                        {
                            strRet[0] = "M";
                            strRet[2] = b[CommStart + 5].ToString();
                            break;

                        }

                    // set freq data
                    case 0x05:
                        {
                            freq[0] = b[CommStart + 5];
                            freq[1] = b[CommStart + 6];
                            freq[2] = b[CommStart + 7];
                            freq[3] = b[CommStart + 8];
                            freq[4] = b[CommStart + 9];

                            strRet[0] = "F";
                            strRet[1] = String.Format("{0:x2}", freq[4]).ToUpper() + String.Format("{0:x2}", freq[3]).ToUpper() +
                                     String.Format("{0:x2}", freq[2]).ToUpper() + String.Format("{0:x2}", freq[1]).ToUpper() +
                                     String.Format("{0:x2}", freq[0]).ToUpper();
                            break;
                        }
                    // set mode
                    case 0x06:
                        {
                            strRet[0] = "M";
                            strRet[2] = b[CommStart + 5].ToString();
                            break;
                        }

                    default:
                        break;

                }

            }
            return strRet;
        }

        private void ShowFreq(long newfreq)
        {
            string sHz;
            String sKHz;
            string sMHz;

            long itemp = (newfreq % 1000);
            sHz = itemp.ToString().PadLeft(3, '0');

            newfreq = newfreq / 1000;
            itemp = (newfreq % 1000);
             sKHz = itemp.ToString().PadLeft(3, '0');

            newfreq = newfreq / 1000;
            itemp = newfreq;
            sMHz =  itemp.ToString() + ".";

            FreqButton.Text =sMHz+sKHz+" "+sHz;
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            this.Invoke(new EventHandler(DoUpdate));
        }

        private void CustomStepButton_Click(object sender, EventArgs e)
        {
            iCustomStep = 1;
            fStepMHZ = (int)mHzCustomStepNunericUpDown.Value;
            fStepKHZ = (int)kHzCustomStepNunericUpDown.Value;
            fStepHZ = (int)HzCustomStepNunericUpDown.Value;
            fStep = (fStepMHZ * 1000000) + (fStepKHZ * 1000) + (fStepHZ);

            stepButton1.ForeColor = System.Drawing.Color.Black;
            stepButton2.ForeColor = System.Drawing.Color.Black;
            stepButton3.ForeColor = System.Drawing.Color.Black;
            stepButton4.ForeColor = System.Drawing.Color.Black;
            stepButton5.ForeColor = System.Drawing.Color.Black;
            stepButton6.ForeColor = System.Drawing.Color.Black;
            stepButton7.ForeColor = System.Drawing.Color.Black;
            stepButton8.ForeColor = System.Drawing.Color.Black;
            stepButton9.ForeColor = System.Drawing.Color.Black;
            stepButton10.ForeColor = System.Drawing.Color.Black;
            stepButton11.ForeColor = System.Drawing.Color.Black;
            stepButton12.ForeColor = System.Drawing.Color.Black;
            CustomStepButton.ForeColor = System.Drawing.Color.White;
        }

        private void mHzCustomStepNunericUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (iCustomStep == 1)
            {
                fStepMHZ = (int)mHzCustomStepNunericUpDown.Value;
                fStep = (fStepMHZ * 1000000) + (fStepKHZ * 1000) + (fStepHZ);
            }
        }

        private void kHzCustomStepNunericUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (iCustomStep == 1)
            {
                fStepKHZ = (int)kHzCustomStepNunericUpDown.Value;
                fStep = (fStepMHZ * 1000000) + (fStepKHZ * 1000) + (fStepHZ);
            }
        }

        private void HzCustomStepNunericUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (iCustomStep == 1)
            {
                fStepHZ = (int)HzCustomStepNunericUpDown.Value;
                fStep = (fStepMHZ * 1000000) + (fStepKHZ * 1000) + (fStepHZ);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //THE TEST

            //fe fe 00 6c 03 fd 
       

                                        // $FE   $FE   ra    $E0   $03    $FD
            byte[] buffer1 = new byte[6] {0xFe, 0xFe, 0x00 ,0x6c, 0x15,0xFd };
            serialPort1.Write(buffer1, 0, 6);
            
            Application.DoEvents();
                                     //$FE $FE   ra    $E0   $04    $FD
         //   buffer1 = new byte[6] { 0xFe, 0xFe, 0x00, 0x6c, 0x04, 0xFd };
         //   serialPort1.Write(buffer1, 0, 6);
         //   Application.DoEvents();

           //  byte[] buffer1 = new byte[7] {0xFE, 0xFE, 0x6C ,0xE0, 0x15,0x01,0xFD };
          //  serialPort1.Write(buffer1, 0, 7);



           

            

            


        }

        private void ScanButton_Click(object sender, EventArgs e)
        {
            byte SQL = 0;

            //long sFreq = 430000000;
            sBreak = 0;
            

            long sFreq = sLoFreq;

            while (SQL == 0) 

            {
                long sinput = sFreq;
                byte[] sResult = new byte[5];

                sResult[0] = (byte)(sinput % 100);
                sinput = sinput / 100;
                sResult[1] = (byte)(sinput % 100);
                sinput = sinput / 100;
                sResult[2] = (byte)(sinput % 100);
                sinput = sinput / 100;
                sResult[3] = (byte)(sinput % 100);
                sinput = sinput / 100;
                sResult[4] = (byte)(sinput % 100);

                byte[] sbuffer = new byte[12];

                sbuffer[0] = 0xFE; //Sync
                sbuffer[1] = 0xFE; //Sync 
                sbuffer[2] = 0x6C; //Addr Receiver
                sbuffer[3] = 0x0E; //Addr Controller
                sbuffer[4] = 0x00; //Send Freq 

                sbuffer[5] = fdata[sResult[0]];
                sbuffer[6] = fdata[sResult[1]];
                sbuffer[7] = fdata[sResult[2]];
                sbuffer[8] = fdata[sResult[3]];
                sbuffer[9] = fdata[sResult[4]];
            
                sbuffer[10] = 0xFD;  //End operation

                serialPort1.Write(sbuffer, 0, 12);
                Application.DoEvents();
                ShowFreq(sFreq);

                //sFreq = sFreq + fStep;

                if (sFreq >= sHIFreq)
                {
                    sFreq = sLoFreq;
                }
                else
                {
                    sFreq = sFreq + fStep;
                }

                if (sBreak == 1)
                {
                    break;
                }

                //if (sFreq > sHIFreq)  
                //{
                //    SQL = 1;
                //}

            }

        }








        private void ScanHIButton_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = false;

            if (Dialed != "")
            {
                _Freq = Dialed.Split('.');

                if ((_Freq[0] != null) & (_Freq[0] != ""))
                {
                    if (int.Parse(_Freq[0], System.Globalization.NumberStyles.Integer) >= 0)
                    {
                        if (_Freq[0].Length > 4)
                        {
                            dMhz = _Freq[0].Substring(0, 4);
                        }
                        else
                        {
                            dMhz = _Freq[0];
                        }
                    }
                }

                if (_Freq.Length > 1)
                {

                    if ((_Freq[1] != null) & (_Freq[1] != ""))
                    {
                        if (int.Parse(_Freq[1], System.Globalization.NumberStyles.Integer) >= 0)
                        {
                            if (_Freq[1].Length < 3)
                            {
                                dKhz = _Freq[1].PadRight(3, '0');
                            }
                            else
                            {
                                if (_Freq[1].Length > 3)
                                {
                                    dKhz = _Freq[1].Substring(0, 3);
                                }
                                else
                                {
                                    dKhz = _Freq[1];
                                }
                            }
                        }
                    }
                }
                else
                {
                    dKhz = "0";
                }

            }
            Dialed = "";

            mHz = int.Parse(dMhz);
            kHz = int.Parse(dKhz);
            Hz = 0;
            Freq = (mHz * 1000000L) + (kHz * 1000) + Hz;

            

            long HInewfreq = Freq;
            sHIFreq = HInewfreq;
            string sHz;
            String sKHz;
            string sMHz;
            

            long itemp = (HInewfreq % 1000);
            sHz = itemp.ToString().PadLeft(3, '0');

            HInewfreq = HInewfreq / 1000;
            itemp = (HInewfreq % 1000);
            sKHz = itemp.ToString().PadLeft(3, '0');

            HInewfreq = HInewfreq / 1000;
            itemp = HInewfreq;
            sMHz = itemp.ToString() + ".";

            ScanHIButton.Text = sMHz + sKHz + " " + sHz;

            
            SetFreq();
            ShowFreq(Freq);

        }

        private void ScanLoButton_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = false;

            if (Dialed != "")
            {
                _Freq = Dialed.Split('.');

                if ((_Freq[0] != null) & (_Freq[0] != ""))
                {
                    if (int.Parse(_Freq[0], System.Globalization.NumberStyles.Integer) >= 0)
                    {
                        if (_Freq[0].Length > 4)
                        {
                            dMhz = _Freq[0].Substring(0, 4);
                        }
                        else
                        {
                            dMhz = _Freq[0];
                        }
                    }
                }

                if (_Freq.Length > 1)
                {

                    if ((_Freq[1] != null) & (_Freq[1] != ""))
                    {
                        if (int.Parse(_Freq[1], System.Globalization.NumberStyles.Integer) >= 0)
                        {
                            if (_Freq[1].Length < 3)
                            {
                                dKhz = _Freq[1].PadRight(3, '0');
                            }
                            else
                            {
                                if (_Freq[1].Length > 3)
                                {
                                    dKhz = _Freq[1].Substring(0, 3);
                                }
                                else
                                {
                                    dKhz = _Freq[1];
                                }
                            }
                        }
                    }
                }
                else
                {
                    dKhz = "0";
                }

            }
            Dialed = "";

            mHz = int.Parse(dMhz);
            kHz = int.Parse(dKhz);
            Hz = 0;
            Freq = (mHz * 1000000L) + (kHz * 1000) + Hz;
            mHz = int.Parse(dMhz);
            kHz = int.Parse(dKhz);
            Hz = 0;
            Freq = (mHz * 1000000L) + (kHz * 1000) + Hz;
            


            long LOnewfreq = Freq;
            sLoFreq = LOnewfreq;
            string sHz;
            String sKHz;
            string sMHz;
            

            long itemp = (LOnewfreq % 1000);
            sHz = itemp.ToString().PadLeft(3, '0');

            LOnewfreq = LOnewfreq / 1000;
            itemp = (LOnewfreq % 1000);
            sKHz = itemp.ToString().PadLeft(3, '0');

            LOnewfreq = LOnewfreq / 1000;
            itemp = LOnewfreq;
            sMHz = itemp.ToString() + ".";

            ScanLoButton.Text = sMHz + sKHz + " " + sHz;
            
            SetFreq();
            ShowFreq(Freq);
        }

        private void FreqButton_Click(object sender, EventArgs e)
        {
            DIALtimer.Enabled = false;

            if (Dialed != "")
            {
                _Freq = Dialed.Split('.');

                if ((_Freq[0] != null) & (_Freq[0] != ""))
                {
                    if (int.Parse(_Freq[0], System.Globalization.NumberStyles.Integer) >= 0)
                    {
                        if (_Freq[0].Length > 4)
                        {
                            dMhz = _Freq[0].Substring(0, 4);
                        }
                        else
                        {
                            dMhz = _Freq[0];
                        }
                    }
                }

                if (_Freq.Length > 1)
                {

                    if ((_Freq[1] != null) & (_Freq[1] != ""))
                    {
                        if (int.Parse(_Freq[1], System.Globalization.NumberStyles.Integer) >= 0)
                        {
                            if (_Freq[1].Length < 3)
                            {
                                dKhz = _Freq[1].PadRight(3, '0');
                            }
                            else
                            {
                                if (_Freq[1].Length > 3)
                                {
                                    dKhz = _Freq[1].Substring(0, 3);
                                }
                                else
                                {
                                    dKhz = _Freq[1];
                                }
                            }
                        }
                    }
                }
                else
                {
                    dKhz = "0";
                }

            }
            Dialed = "";

            mHz = int.Parse(dMhz);
            kHz = int.Parse(dKhz);
            Hz = 0;
            Freq = (mHz * 1000000L) + (kHz * 1000) + Hz;

            SetFreq();
            ShowFreq(Freq);
        }

        

 
    }
}